﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Security.Permissions;

namespace System.IO
{
    public static class DirectoryInfoUtil
    {
        /// <summary>
        /// 에러 발생 지역 다른 스레드가 실행 중일 떄 삭제 불가 
        /// </summary>
        /// <param name="directory"></param>
        /// <param name="tryEx"></param>
        [FileIOPermission(SecurityAction.LinkDemand)]
        public static void Empty(this System.IO.DirectoryInfo directory, bool tryEx)
        {
            try
            {
                directory.GetFiles().AsParallel().ForAll(f =>
                {
                    System.Diagnostics.Debug.WriteLine("delete : " + f.FullName);
                    f.Attributes = System.IO.FileAttributes.Normal;
                    f.Delete();
                });

                directory.GetDirectories().AsParallel().ForAll(d =>
                {
                    if (d.GetDirectories().Count() > 0)
                    {
                        d.Empty(false);
                        d.Delete(true);
                    }
                    else
                    {
                        System.Diagnostics.Debug.WriteLine("delete : " + d.FullName);
                        d.Delete(true);
                    }
                });
            }
            catch (Exception ex)
            {
                if (!tryEx)
                {
                    directory.Empty(true);
                    System.Threading.Thread.Sleep(6000);
                }
                else
                    throw new Exception(ex.ToString());
            }

        }
    }
}
